(function () {
    const socket = io('http://localhost:5555');
    const elId = 'content-render-status';
    const elStyle = `
        position: fixed;
        top: 0;
        left: 0;
        right: 0;
        padding: 10px;
        color: #fff;
        font-family: monospace;
        font-size: 1em;
        overflow: auto;
        word-wrap: break-word;
        z-index: 1000;
    `.replace(/\s+/g, ' ').trim();

    socket.on('content-templates-changed', () => {
        let el = document.getElementById(elId);
        if (!el) {
            document.body.insertAdjacentHTML('beforeend', `<div id="${elId}" style="${elStyle}"></div>`);
            el = document.getElementById(elId);
        }

        el.style.backgroundColor = '#006400';
        el.textContent = `Rendering content using "${__contentTemplateInfo.name}" template...`;
        console.info(el.textContent);

        var body = {
            pathname: location.pathname,
            templateName: __contentTemplateInfo.name,
            model: __contentTemplateInfo.model
        };

        fetch('http://localhost:5555', { method: "POST", body: JSON.stringify(body) })
            .then(function (result) {
                if (result.ok) {
                    el.textContent = `Success! Reloading...`;
                    console.info(el.textContent);
                    location.reload();
                    return;
                }
                result.text().then(error => {
                    el.style.backgroundColor = '#8B0000';
                    el.textContent = error;
                    console.error(error);
                })
            });
    });
})();